package com.elab.core.aop.annotations;

import com.elab.core.spring.config.DataSourceConfigBean;
import com.elab.core.spring.config.JdbcBeanConfig;
import com.elab.core.spring.config.TransactionConfigBean;
import org.springframework.context.annotation.Import;

import java.lang.annotation.*;

@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.TYPE)
@Documented
@Import({DataSourceConfigBean.class, JdbcBeanConfig.class, TransactionConfigBean.class})
public @interface EnableElabDB {

}
