package com.elab.mq.rocket.anno;

import com.elab.core.aop.annotations.EnableElabDB;
import com.elab.mq.rocket.configuration.RocketMQConfiguration;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Import;

import java.lang.annotation.*;

@Target({ElementType.TYPE})
@Retention(RetentionPolicy.RUNTIME)
@Documented
@Inherited
@Import({RocketMQConfiguration.class})
@EnableElabDB
@ComponentScan({"com.elab.mq.rocket.msg"})
public @interface EnableRocketMQ {
    String[] value() default {};
}