//package com.elab.example.springbootdemo.configuration;
//
//import org.apache.kafka.clients.producer.KafkaProducer;
//import org.apache.kafka.clients.producer.ProducerConfig;
//import org.springframework.beans.factory.annotation.Value;
//import org.springframework.context.annotation.Bean;
//import org.springframework.context.annotation.Configuration;
//
//import java.util.Properties;
//
///**
// * kafka消息队列集成配置
// *
// * @author ： liukx
// * @time ： 2019/8/7 - 13:48
// */
//@Configuration
//public class KafkaConfiguration {
//
//    @Value("${kafka.bootstrap.servers}")
//    private String bootstrapServers;
//
//    @Value("${kafka.topic}")
//    private String topic;
//
//
//    @Bean
//    public KafkaProducer kafkaProducer() {
//        Properties props = new Properties();
//        //设置接入点，请通过控制台获取对应 Topic 的接入点
//        props.put(ProducerConfig.BOOTSTRAP_SERVERS_CONFIG, bootstrapServers);
//        //消息队列 Kafka 消息的序列化方式
//        props.put(ProducerConfig.KEY_SERIALIZER_CLASS_CONFIG, "org.apache.kafka.common.serialization.StringSerializer");
//        props.put(ProducerConfig.VALUE_SERIALIZER_CLASS_CONFIG, "org.apache.kafka.common.serialization.StringSerializer");
//        //请求的最长等待时间
//        props.put(ProducerConfig.MAX_BLOCK_MS_CONFIG, 30 * 1000);
//
//        //构造 Producer 对象，注意，该对象是线程安全的。
//        //一般来说，一个进程内一个 Producer 对象即可。如果想提高性能，可构造多个对象，但最好不要超过 5 个
//        KafkaProducer<String, String> producer = new KafkaProducer<String, String>(props);
//        return producer;
//    }
//
//
//}
